<html>
   <head>
      <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
   
      <link rel="stylesheet" href="private/helpwin.css">
      <title>MATLAB File Help: iFunc</title>
   </head>
   <body>
      <!--Single-page help-->
      <table border="0" cellspacing="0" width="100%">
         <tr class="subheader">
            <td class="headertitle">MATLAB File Help: iFunc</td>
            <td class="subheader-left">View code for iFunc</td>
            <td class="subheader-right">Default Topics</td>
         </tr>
      </table>
      <div class="title">iFunc</div>
      <div class="helptext"><pre><!--helptext -->  <span class="helptopic">iFunc</span> Create a model for fitting.
    MODEL = <span class="helptopic">iFunc</span>(...) Creates a fit model function.
 
  Any Fit Model function can be created from a mathematical expression, a
  structure, a function handle or an other object.
 
  The model can store the following information members:
    Dimension:        The model dimensionality. 0=scalar, 1,2,3,4... 
                        a negative dimension is used to indicate a variable dimensionality.
    Expression:       The expression for the function (string) or function handle
                        signal=Expression(p, x,y, ...)
                          The parameter names surrounded by "" are replaced
                          by the corresponing p(n)
                        the <span class="helptopic">iFunc</span> object itself is named 'this' in the Expression
    Guess:            Vector, expression or function to evaluate in order to obtain
                        guessed parameters from axes x,y,z, ... and signal
                        p=Guess(x,y,z, ..., signal) should return a vector. NaN values 
                        are not set.
    Name:             A short name for the function
    ParameterValues:  Some parameter values to be used e.g. as starting parameters
                        for a fit procedure or a plot
    Description:      A string describing the model
    Parameters:       The Parameter names (cellstr)
    Constraint:       A structure with fields:
                        min:   a vector of minimal values per parameter
                        max:   a vector of maximal values per parameter
                        fixed: a vector of 0(free) and 1(fixed) per parameter
                        set:   a cell of expressions per parameter (restraints)
                        eval:  making use of 'p', 'constraints', and 'options' 
                               and returning modified 'p'.
                                as a function_handle: p=expression(p, x,y,...). 
                                as a char/cellstr where parameter names surrounded
                                by "" are replaced by the corresponding p(n). 
                                NaN values are not changed.
 
  Creating the object:
  ------------------------------------------------------------------------------
    From a character string
      the Expression should make use of x,y,z,t,u,v,w to denote axes of rank 1-7,
      and the model Parameters are specified using 'p(n)' vector elements.
        <span class="helptopic">iFunc</span>('p(1)*x+p(2)')
 
    From a structure, with <span class="helptopic">iFunc</span> object fields (see above) and alias fields:
      x0          -&gt; Guess
      objective   -&gt; Expression
      pars        -&gt; Parameters
      function    -&gt; Name
 
    From a function handle
      The function should have syntax model(p, x,y,...) and return the model value.
        <span class="helptopic">iFunc</span>(@(p,x) p(1)*x+p(2))
 
    From a script/function 
      The file should use 'p' as adjustable parameters, and optionally axes 'x', 'y', ...
 
    From a SpinW object
        <span class="helptopic">iFunc</span>(sw_model('squareAF',2,0))
 
    From a file in MAT, M, YAML, JSON, XML format holding a model (<span class="helptopic">iFunc</span>/saveas)
        <span class="helptopic">iFunc</span>('filename_model'). See <span class="helptopic">iFunc</span>/saveas
 
    From a data set (iData) or data file
        <span class="helptopic">iFunc</span>(iData('filename')); parameters allow to scale and shift.
 
  Using the object:
  ------------------------------------------------------------------------------
    Once the object has been created, you can evaluate it with: object(p, x, y, ...)
    The usual mathematical operators can be used to manipulate <span class="helptopic">iFunc</span> objects.
    You can use guessed Model parameters with syntax: object('guess', x,y, ...)
 
    The syntax <span class="helptopic">iFunc</span>(iData object) evaluates the <span class="helptopic">iFunc</span> model using the iData
      object axes, and returns the model value as a numerical array. To get the
      result as an iData, use syntax iData(<span class="helptopic">iFunc</span> object) [the opposite syntax].
 
    The Model expression is               object.Expression
    The Model parameter names are         object.Parameters
    The Model parameter values (when set) object.ParameterValues or object.p
    A single parameter can be accessed    object.&lt;ParameterName&gt; or object.p(index)
 
  Scan model parameters:
  ------------------------------------------------------------------------------
  It is possible to scan model parameters when using vectors as value for the
  parameters. To achieve that, the parameter values must be given as a named 
  structure.
  For instance, to scan the Intensity parameter in a gaussian, use:
    model = gauss1;
    p.Intensity= [ .5:.25:2 ];      % from 0.5 to 2 by steps of .25
    v=iData(model, p);              % evaluate as iData sets.
    plot(cat(2,v));                 % plot the scan as a surface
 
  Optimise model parameters:
  ------------------------------------------------------------------------------
  To optimise model parameters, you should first fix the non-varying
  parameters, and possibly bound the others. Then the optimisation is launched with
  any optimiser. To maximise the model, use '-model' as argument, as in the example:
    model = gauss1;
    fix(model, 'all'); model.Intensity='free';
    model.Intensity=[0 1 2];    % bounds and starting value
    model.HalfWidth = 0.5;
    p = fmin(-model, [])        % return the optimal parameters to maximise the model
 
  Example: b=<span class="helptopic">iFunc</span>(@(p,x) p(1)*x+p(2)); isa(b, '<span class="helptopic">iFunc</span>')
  Example: b=<span class="helptopic">iFunc</span>('p(1)*x+p(2)'); isa(b, '<span class="helptopic">iFunc</span>')
  Example: b=<span class="helptopic">iFunc</span>('signal=p(1)*x+p(2);'); isa(b, '<span class="helptopic">iFunc</span>')</pre></div><!--after help --><!--seeAlso--><div class="footerlinktitle">See also</div><div class="footerlink"> iFunc, iFunc/feval, iFunc/plot, iFunc/fits, iFunc/load, iFunc/saveas, methods
</div>
      <!--Class-->
      <div class="sectiontitle">Class Details</div>
      <table class="class-details">
         <tr>
            <td class="class-detail-label">Sealed</td>
            <td>false</td>
         </tr>
         <tr>
            <td class="class-detail-label">Construct on load</td>
            <td>false</td>
         </tr>
      </table>
      <!--Constructors-->
      <div class="sectiontitle"><a name="constructors"></a>Constructor Summary
      </div>
      <table class="summary-list">
         <tr class="summary-item">
            <td class="name">iFunc</td>
            <td class="m-help">Create a model for fitting.&nbsp;</td>
         </tr>
      </table>
      <!--Properties-->
      <div class="sectiontitle"><a name="properties"></a>Property Summary
      </div>
      <table class="summary-list">
         <tr class="summary-item">
            <td class="name">Constraint</td>
            <td class="m-help">Restraints/constraints to evaluate before computing the Expression, can be: a function_handle, a char/cellstr, a vector (length
               p), a structure with fields: min, max, fixed.&nbsp;
            </td>
         </tr>
         <tr class="summary-item">
            <td class="name">Date</td>
            <td class="m-help">Creation date.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Description</td>
            <td class="m-help">Description (long).&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Dimension</td>
            <td class="m-help">Model dimensionality (1,2,3,4...) 0=scalar=empty. a negative dimension is used to indicate a variable dimensionality.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Duration</td>
            <td class="m-help">Time spent for the evaluation.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Eval</td>
            <td class="m-help">Code to evaluate for the model value.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Expression</td>
            <td class="m-help">Expression to evaluate to get the function value, char or function_handle(p, x,y, ...).&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Guess</td>
            <td class="m-help">Default parameter set or expression or function handle, char or function_handle(x,y,..., signal, Parameters{}) or 'automatic'.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Name</td>
            <td class="m-help">Model Name (short).&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">ParameterValues</td>
            <td class="m-help">Current parameter values.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Parameters</td>
            <td class="m-help">Model parameter names, a cellstr or words or a single string of words separated by spaces, or a structure with parameter values.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">Tag</td>
            <td class="m-help">Unique ID.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="name">UserData</td>
            <td class="m-help">User data storage area.&nbsp;</td>
         </tr>
      </table>
      <!--Methods-->
      <div class="sectiontitle"><a name="methods"></a>Method Summary
      </div>
      <table class="summary-list">
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">abs</td>
            <td class="m-help">Absolute value of iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">acos</td>
            <td class="m-help">Arc cosine of iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">acosh</td>
            <td class="m-help">Inverse hyperbolic cosine of iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">asin</td>
            <td class="m-help">Inverse sine of iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">asinh</td>
            <td class="m-help">Inverse hyperbolic sine of iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">atan</td>
            <td class="m-help">Arc tangent of iFunc object.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">atanh</td>
            <td class="m-help">Inverse hyperbolic tangent of iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">binary</td>
            <td class="m-help">Apply binary operation on model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">ceil</td>
            <td class="m-help">Upper integer round of iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">cell2struct</td>
            <td class="m-help">Convert model parameters to structure.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">cellstr</td>
            <td class="m-help">Create cell array of strings from iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">char</td>
            <td class="m-help">Convert iFunc model into character array.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">conj</td>
            <td class="m-help">Conjugate of iFunc model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">conv</td>
            <td class="m-help">Convolution of models.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">convn</td>
            <td class="m-help">Convolution of model with a response function (normalized).&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">copyobj</td>
            <td class="m-help">Make copy of model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">cos</td>
            <td class="m-help">Cosine of model in radians.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">cosh</td>
            <td class="m-help">Hyperbolic cosine of model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">ctranspose</td>
            <td class="m-help">'      Complex conjugate transpose of model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">del2</td>
            <td class="m-help">Discrete Laplacian of model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">disp</td>
            <td class="m-help">Display model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">display</td>
            <td class="m-help">Display model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">edit</td>
            <td class="m-help">Edit a model with a window dialogue.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">exp</td>
            <td class="m-help">Exponential.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">feval</td>
            <td class="m-help">Evaluate model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">fits</td>
            <td class="m-help">Fit a model to data.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">fliplr</td>
            <td class="m-help">Flip model in left/right direction.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">flipud</td>
            <td class="m-help">Flip model in up/down direction.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">floor</td>
            <td class="m-help">Round towards minus infinity.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">get</td>
            <td class="m-help">Get model properties.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">guess</td>
            <td class="m-help">Guess starting parameters for model fit.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">imag</td>
            <td class="m-help">Complex imaginary part.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">isempty</td>
            <td class="m-help">True for empty model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">isfield</td>
            <td class="m-help">True if field or parameter is in model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">load</td>
            <td class="m-help">Load model from a file.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">log</td>
            <td class="m-help">Natural logarithm.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">log10</td>
            <td class="m-help">Common (base 10) logarithm.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">minus</td>
            <td class="m-help">-      Minus.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">mlock</td>
            <td class="m-help">Set model parameter locked (fixed) state.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">mpower</td>
            <td class="m-help">^      Model matrix-power.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">mrdivide</td>
            <td class="m-help">./     Orthogonal matrix-divide.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">mtimes</td>
            <td class="m-help">*     Model matrix-multiply.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">munlock</td>
            <td class="m-help">Set model parameter unlocked (free) state.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">ndims</td>
            <td class="m-help">Number of dimensions of model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">norm</td>
            <td class="m-help">Model norm.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">not</td>
            <td class="m-help">~      Logical not.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">ones</td>
            <td class="m-help">Ones model array.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">plot</td>
            <td class="m-help">Plot model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">plus</td>
            <td class="m-help">+      Plus.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">power</td>
            <td class="m-help">.^     Model power.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">rdivide</td>
            <td class="m-help">./     Divide.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">real</td>
            <td class="m-help">Complex real part.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">round</td>
            <td class="m-help">Round towards nearest integer.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">runtests</td>
            <td class="m-help">Run a set of tests on object methods.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">saveas</td>
            <td class="m-help">Save model in desired output format.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">set</td>
            <td class="m-help">Set model properties.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">shiftdim</td>
            <td class="m-help">Shift model axis by a value.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">sign</td>
            <td class="m-help">Signum function.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">sin</td>
            <td class="m-help">Sine of argument in radians.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">sinh</td>
            <td class="m-help">Hyperbolic sine.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">sqrt</td>
            <td class="m-help">Square root.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">subplot</td>
            <td class="m-help">Plot models in tiled positions.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">subsasgn</td>
            <td class="m-help">Subscripted assignement.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">subsref</td>
            <td class="m-help">Subscripted reference.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">tan</td>
            <td class="m-help">Hyperbolic tangent in radians.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">tanh</td>
            <td class="m-help">Hyperbolic tangent.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">times</td>
            <td class="m-help">.*     Model multiply.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">title</td>
            <td class="m-help">Get or set the model Name.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">transpose</td>
            <td class="m-help">.'     Complex non-conjugate transpose of model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">uminus</td>
            <td class="m-help">-      Unary minus.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">unary</td>
            <td class="m-help">Handles unary model operations.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">uplus</td>
            <td class="m-help">+      Unary plus, makes a copy of model.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">xcorr</td>
            <td class="m-help">Cross-Correlation of models.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">xlim</td>
            <td class="m-help">Model limits.&nbsp;</td>
         </tr>
         <tr class="summary-item">
            <td class="attributes">
               &nbsp;
               
            </td>
            <td class="name">zeros</td>
            <td class="m-help">Zeros model array.&nbsp;</td>
         </tr>
      </table>
   </body>
</html>
